Index: drools-core/META-INF/MANIFEST.MF
===================================================================
--- drools-core/META-INF/MANIFEST.MF	(revision 33386)
+++ drools-core/META-INF/MANIFEST.MF	(working copy)
@@ -285,13 +285,13 @@
  APSHOT",org.drools.reteoo;version="5.1.0.SNAPSHOT"
 Tool: Bnd-0.0.357
 Bundle-Name: Drools :: Core
-Created-By: 1.6.0_18 (Sun Microsystems Inc.)
+Created-By: 1.6.0_20 (Sun Microsystems Inc.)
 Require-Bundle: org.drools.api;visibility:=reexport;bundle-version="5.
  1.0.SNAPSHOT"
 Bundle-Vendor: JBoss Inc.
 DynamicImport-Package: *
 Bundle-Version: 5.1.0.SNAPSHOT
-Bnd-LastModified: 1275904958179
+Bnd-LastModified: 1275946201162
 Bundle-Activator: org.drools.osgi.core.Activator
 Bundle-ManifestVersion: 2
 Bundle-Description: A rule production system
Index: drools-decisiontables/META-INF/MANIFEST.MF
===================================================================
--- drools-decisiontables/META-INF/MANIFEST.MF	(revision 33386)
+++ drools-decisiontables/META-INF/MANIFEST.MF	(working copy)
@@ -11,12 +11,12 @@
 Private-Package: python-dt;version="5.1.0.SNAPSHOT"
 Tool: Bnd-0.0.357
 Bundle-Name: Drools :: Decision Tables
-Created-By: 1.6.0_18 (Sun Microsystems Inc.)
+Created-By: 1.6.0_20 (Sun Microsystems Inc.)
 Require-Bundle: org.drools.core;bundle-version="5.1.0.SNAPSHOT"
 Bundle-Vendor: JBoss Inc.
 DynamicImport-Package: org.drools.*
 Bundle-Version: 5.1.0.SNAPSHOT
-Bnd-LastModified: 1275721232831
+Bnd-LastModified: 1275946162007
 Bundle-Activator: org.drools.osgi.decisiontables.Activator
 Bundle-ManifestVersion: 2
 Bundle-Description: A rule production system
Index: drools-decisiontables/src/test/java/org/drools/decisiontable/parser/LhsBuilderTest.java
===================================================================
--- drools-decisiontables/src/test/java/org/drools/decisiontable/parser/LhsBuilderTest.java	(revision 33386)
+++ drools-decisiontables/src/test/java/org/drools/decisiontable/parser/LhsBuilderTest.java	(working copy)
@@ -47,14 +47,80 @@
         
         assertEquals("Foo(bar == 42)\neval(true)", builder.getResult());
     }
-    
+
+	public void testForAllOr() {
+		LhsBuilder builder = new LhsBuilder("Person");
+		builder.addTemplate(1, "forall(||){age < $}");
+		builder.addCellValue(1, "42");
+		assertEquals("Person(age < 42)", builder.getResult());
+	}
+
+	public void testForAllOrPrefix() {
+		LhsBuilder builder = new LhsBuilder("Person");
+		builder.addTemplate(1, "age < 10 && forall(||){age < $}");
+		builder.addCellValue(1, "42");
+		assertEquals("Person(age < 10 && age < 42)", builder.getResult());
+	}
+	
+	public void testForAllOrCSV() {
+		LhsBuilder builder = new LhsBuilder("Person");
+		builder.addTemplate(1, "forall(||){age < $}");
+		builder.addCellValue(1, "42, 43, 44");
+		assertEquals("Person(age < 42 || age < 43 || age < 44)", builder
+				.getResult());
+	}
+
+	public void testForAllAnd() {
+		LhsBuilder builder = new LhsBuilder("Person");
+		builder.addTemplate(1, "forall(&&){age < $}");
+		builder.addCellValue(1, "42");
+		assertEquals("Person(age < 42)", builder.getResult());
+	}
+
+	public void testForAllAndCSV() {
+		LhsBuilder builder = new LhsBuilder("Person");
+		builder.addTemplate(1, "forall(&&){age < $}");
+		builder.addCellValue(1, "42, 43, 44");
+		assertEquals("Person(age < 42 && age < 43 && age < 44)", builder
+				.getResult());
+	}
+
+	public void testForAllAndForAllOrCSVMultiple() {
+		LhsBuilder builder = new LhsBuilder("Person");
+		builder.addTemplate(1, "forall(&&){age < $ || age == $}");
+		builder.addCellValue(1, "42, 43, 44");
+		assertEquals(
+				"Person(age < 42 || age == 42 && age < 43 || age == 43 && age < 44 || age == 44)",
+				builder.getResult());
+	}
+
+	public void testForAllsAndForAllOrCSVMultiple() {
+		LhsBuilder builder = new LhsBuilder("Person");
+		builder.addTemplate(1, "forall(&&){age < $ || age == $} && forall(&&){age < $ || age == $}");
+		builder.addCellValue(1, "42, 43, 44");
+		assertEquals(
+				"Person(age < 42 || age == 42 && age < 43 || age == 43 && age < 44 || age == 44 && age < 42 || age == 42 && age < 43 || age == 43 && age < 44 || age == 44)",
+				builder.getResult());
+	}
+	
     public void testIdentifyFieldTypes() {
         LhsBuilder builder = new LhsBuilder("");
         assertEquals(FieldType.SINGLE_FIELD, builder.calcFieldType("age"));
         assertEquals(FieldType.OPERATOR_FIELD, builder.calcFieldType("age <"));
         assertEquals(FieldType.NORMAL_FIELD, builder.calcFieldType("age < $param"));
-        
-        
+        assertEquals(FieldType.NORMAL_FIELD, builder.calcFieldType("forall(||){age < $}"));
+        assertEquals(FieldType.NORMAL_FIELD, builder.calcFieldType("forall(&&){age < $}"));
+        assertEquals(FieldType.NORMAL_FIELD, builder.calcFieldType("forall(,){age < $}"));
+        assertEquals(FieldType.NORMAL_FIELD, builder.calcFieldType("forall(){age < $}"));
+        assertEquals(FieldType.NORMAL_FIELD, builder.calcFieldType("forall(){age < $} && forall(){age == $}"));
+        assertEquals(FieldType.NORMAL_FIELD, builder.calcFieldType("x && forall(){age < $} && forall(){age == $}"));
+        assertEquals(FieldType.NORMAL_FIELD, builder.calcFieldType("x && forall(){age < $} && forall(){age == $} && y"));
+        assertEquals(FieldType.SINGLE_FIELD, builder.calcFieldType("age < $para"));
+        assertEquals(FieldType.SINGLE_FIELD, builder.calcFieldType("forall{||}{age < $}"));
+        assertEquals(FieldType.SINGLE_FIELD, builder.calcFieldType("forall(){}"));
+        assertEquals(FieldType.SINGLE_FIELD, builder.calcFieldType("forall(){age < $"));
+        assertEquals(FieldType.SINGLE_FIELD, builder.calcFieldType("forall(){,"));
+        assertEquals(FieldType.SINGLE_FIELD, builder.calcFieldType("forall({})"));
     }
     
     public void testIdentifyColumnCorrectly() {
Index: drools-decisiontables/src/main/java/org/drools/decisiontable/parser/LhsBuilder.java
===================================================================
--- drools-decisiontables/src/main/java/org/drools/decisiontable/parser/LhsBuilder.java	(revision 33386)
+++ drools-decisiontables/src/main/java/org/drools/decisiontable/parser/LhsBuilder.java	(working copy)
@@ -61,9 +61,9 @@
             constraints.put( key,
                              content );            
         } else if (fieldType == FieldType.SINGLE_FIELD) {
-            constraints.put( key, content + " == \"$param\"" );
+            constraints.put( key, content + " == \"" + SnippetBuilder.PARAM_STRING + "\"" );
         } else if (fieldType == FieldType.OPERATOR_FIELD) {
-            constraints.put( key, content + " \"$param\"" );
+            constraints.put( key, content + " \"" + SnippetBuilder.PARAM_STRING + "\"" );
         }
         
     }
@@ -133,14 +133,17 @@
      * age 
      * age <
      * age == $param
+     * age == $1 || age == $2
+     * forall{age < $}{,}
      * 
      * etc. as we treat them all differently.
      */
-    public FieldType calcFieldType(String content) {
-        if (content.indexOf( "$param" ) != -1 || content.indexOf( "$1" ) != -1 ) {
-            return FieldType.NORMAL_FIELD;
-        }
-        for ( String op : operators ) {
+	public FieldType calcFieldType(String content) {
+		if (!SnippetBuilder.getType(content).equals(
+				SnippetBuilder.SnippetType.SINGLE)) {
+			return FieldType.NORMAL_FIELD;
+		}
+       for ( String op : operators ) {
             if (content.endsWith( op )) {
                 return FieldType.OPERATOR_FIELD;
             }            
Index: drools-persistence-jpa/META-INF/MANIFEST.MF
===================================================================
--- drools-persistence-jpa/META-INF/MANIFEST.MF	(revision 33386)
+++ drools-persistence-jpa/META-INF/MANIFEST.MF	(working copy)
@@ -16,13 +16,13 @@
  action,javax.naming";version="5.1.0.SNAPSHOT"
 Tool: Bnd-0.0.357
 Bundle-Name: Drools :: Persistence :: JPA
-Created-By: 1.6.0_18 (Sun Microsystems Inc.)
+Created-By: 1.6.0_20 (Sun Microsystems Inc.)
 Require-Bundle: org.drools.core;bundle-version="5.1.0.SNAPSHOT", org.d
  rools.compiler;bundle-version="5.1.0.SNAPSHOT"
 Bundle-Vendor: JBoss Inc.
 DynamicImport-Package: *
 Bundle-Version: 5.1.0.SNAPSHOT
-Bnd-LastModified: 1275721199271
+Bnd-LastModified: 1275944051059
 Bundle-ManifestVersion: 2
 Bundle-Description: A rule production system
 Bundle-License: http://www.apache.org/licenses/LICENSE-2.0.txt
Index: drools-compiler/META-INF/MANIFEST.MF
===================================================================
--- drools-compiler/META-INF/MANIFEST.MF	(revision 33386)
+++ drools-compiler/META-INF/MANIFEST.MF	(working copy)
@@ -42,12 +42,12 @@
  .dsl;version="5.1.0.SNAPSHOT"
 Tool: Bnd-0.0.357
 Bundle-Name: Drools :: Compiler
-Created-By: 1.6.0_18 (Sun Microsystems Inc.)
+Created-By: 1.6.0_20 (Sun Microsystems Inc.)
 Require-Bundle: org.drools.core;bundle-version="5.1.0.SNAPSHOT"
 Bundle-Vendor: JBoss Inc.
 DynamicImport-Package: *
 Bundle-Version: 5.1.0.SNAPSHOT
-Bnd-LastModified: 1275904975141
+Bnd-LastModified: 1275943742338
 Bundle-Activator: org.drools.osgi.compiler.Activator
 Bundle-ManifestVersion: 2
 Bundle-Description: A rule production system
Index: drools-templates/META-INF/MANIFEST.MF
===================================================================
--- drools-templates/META-INF/MANIFEST.MF	(revision 33386)
+++ drools-templates/META-INF/MANIFEST.MF	(working copy)
@@ -8,12 +8,12 @@
  rser,org.drools.template.objects";version="5.1.0.SNAPSHOT"
 Tool: Bnd-0.0.357
 Bundle-Name: Drools :: Templates
-Created-By: 1.6.0_18 (Sun Microsystems Inc.)
+Created-By: 1.6.0_20 (Sun Microsystems Inc.)
 Require-Bundle: org.drools.core;bundle-version="5.1.0.SNAPSHOT"
 Bundle-Vendor: JBoss Inc.
 DynamicImport-Package: org.drools.*
 Bundle-Version: 5.1.0.SNAPSHOT
-Bnd-LastModified: 1275721230797
+Bnd-LastModified: 1275946147114
 Bundle-ManifestVersion: 2
 Bundle-Description: A rule production system
 Bundle-License: http://www.apache.org/licenses/LICENSE-2.0.txt
Index: drools-templates/src/test/java/org/drools/template/model/SnippetBuilderTest.java
===================================================================
--- drools-templates/src/test/java/org/drools/template/model/SnippetBuilderTest.java	(revision 33386)
+++ drools-templates/src/test/java/org/drools/template/model/SnippetBuilderTest.java	(working copy)
@@ -92,5 +92,59 @@
                       result );
 
     }
+    
+	public void testForAllAnd() {
+		final String snippet = "forall(&&){something == $}";
+		final SnippetBuilder snip = new SnippetBuilder(snippet);
+		final String result = snip.build("x");
+		assertEquals("something == x", result);
+	}
 
+	public void testForAllAndCSV() {
+		final String snippet = "forall(&&){something == $}";
+		final SnippetBuilder snip = new SnippetBuilder(snippet);
+		final String result = snip.build("x, y");
+		assertEquals("something == x && something == y", result);
+	}
+
+	public void testForAllAndNone() {
+		final String snippet = "forall(&&){something == $}";
+		final SnippetBuilder snip = new SnippetBuilder(snippet);
+		final String result = snip.build("");
+		assertEquals("forall(&&){something == $}", result);
+	}
+
+	public void testForAllAndCSVMultiple() {
+		final String snippet = "forall(&&){something == $ || something == $}";
+		final SnippetBuilder snip = new SnippetBuilder(snippet);
+		final String result = snip.build("x, y");
+		assertEquals(
+				"something == x || something == x && something == y || something == y",
+				result);
+	}
+
+	public void testForAllOr() {
+		final String snippet = "forall(||){something == $}";
+		final SnippetBuilder snip = new SnippetBuilder(snippet);
+		final String result = snip.build("x");
+		assertEquals("something == x", result);
+	}
+
+	public void testForAllOrMultiple() {
+		final String snippet = "forall(||){something == $} && forall(||){something < $}";
+		final SnippetBuilder snip = new SnippetBuilder(snippet);
+		final String result = snip.build("x, y");
+		assertEquals(
+				"something == x || something == y && something < x || something < y",
+				result);
+	}
+	
+	public void testForAllOrAndMultipleWithPrefix() {
+		final String snippet = "something == this && forall(||){something == $} && forall(&&){something < $}";
+		final SnippetBuilder snip = new SnippetBuilder(snippet);
+		final String result = snip.build("x, y");
+		assertEquals(
+				"something == this && something == x || something == y && something < x && something < y",
+				result);
+	}
 }
\ No newline at end of file
Index: drools-templates/src/main/java/org/drools/template/model/SnippetBuilder.java
===================================================================
--- drools-templates/src/main/java/org/drools/template/model/SnippetBuilder.java	(revision 33386)
+++ drools-templates/src/main/java/org/drools/template/model/SnippetBuilder.java	(working copy)
@@ -1,7 +1,9 @@
 package org.drools.template.model;
 
 import java.util.ArrayList;
+import java.util.HashMap;
 import java.util.List;
+import java.util.Map;
 import java.util.regex.Matcher;
 import java.util.regex.Pattern;
 
@@ -36,13 +38,20 @@
  */
 public class SnippetBuilder {
 
-    private static final String PARAM_PREFIX = "$";
+	public enum SnippetType {
+		SINGLE, PARAM, INDEXED, FORALL
+	};
 
-    private static final String PARAM        = SnippetBuilder.PARAM_PREFIX + "param";
+	public static final String PARAM_PREFIX = "$";
+	public static final String PARAM_SUFFIX = "param";
+	public static final String PARAM_STRING = PARAM_PREFIX + PARAM_SUFFIX;
+	public static final String PARAM_FORALL_STRING = "forall";
+	public static final Pattern PARAM_FORALL_PATTERN = Pattern
+			.compile(PARAM_FORALL_STRING + "\\(([^{}]*)\\)\\{([^{}]+)\\}");
 
     private final String        _template;
     
-    private final boolean       single;
+    private final SnippetType   type;
     
     private final Pattern       delimiter;
 
@@ -56,30 +65,65 @@
             throw new RuntimeException( "Script template is null - check for missing script definition." );
         }
         this._template = snippetTemplate;
-        this.single = this._template.indexOf( SnippetBuilder.PARAM_PREFIX + "1" ) < 0;
+        this.type = getType(_template);
         this.delimiter = Pattern.compile( "(.*?[^\\\\])(,|\\z)" );
     }
 
+	public static SnippetType getType(String template) {
+		Matcher forallMatcher = PARAM_FORALL_PATTERN.matcher(template);
+		if (forallMatcher.find())
+			return SnippetType.FORALL;
+		else if (template.indexOf(PARAM_PREFIX + "1") != -1)
+			return SnippetType.INDEXED;
+		else if (template.indexOf(PARAM_STRING) != -1)
+			return SnippetType.PARAM;
+		return SnippetType.SINGLE;
+	}
+    
     /**
      * @param cellValue
      *            The value from the cell to populate the snippet with. If no
      *            place holder exists, will just return the snippet.
      * @return The final snippet.
      */
-    public String build(final String cellValue) {
-        if ( single ) {
-            return buildSingle( cellValue );
-        } else {
-            return buildMulti( cellValue );
-        }
-    }
+	public String build(final String cellValue) {
+		switch (type) {
+		case FORALL:
+			return buildForAll(cellValue);
+		case INDEXED:
+			return buildMulti(cellValue);
+		default:
+			return buildSingle(cellValue);
+		}
+	}
 
+	private String buildForAll(final String cellValue) {
+		final String[] cellVals = split(cellValue);
+		Map<String, String> replacements = new HashMap<String, String>();
+		Matcher forallMatcher = PARAM_FORALL_PATTERN.matcher(_template);
+		while (forallMatcher.find()) {
+			replacements.put(forallMatcher.group(), "");
+			for (int paramNumber = 0; paramNumber < cellVals.length; paramNumber++) {
+				replacements.put(forallMatcher.group(), replacements
+						.get(forallMatcher.group())
+						+ (paramNumber == 0 ? "" : " " + forallMatcher.group(1)
+								+ " ")
+						+ replace(forallMatcher.group(2), PARAM_PREFIX,
+								cellVals[paramNumber].trim(), 256));
+			}
+		}
+		String result = _template;
+		for (String key : replacements.keySet())
+			result = replace(result, key, replacements.get(key), 256);
+		return result.equals("") ? _template : result;
+	}
+	
     private String buildMulti(final String cellValue) {
         final String[] cellVals = split( cellValue );
         String result = this._template;
 
         for ( int paramNumber = 0; paramNumber < cellVals.length; paramNumber++ ) {
-            final String replace = SnippetBuilder.PARAM_PREFIX + (paramNumber + 1);
+            final String replace = PARAM_PREFIX + (paramNumber + 1);
             result = replace( result,
                               replace,
                               cellVals[paramNumber].trim(),
@@ -106,7 +150,7 @@
     private String buildSingle(final String cellValue) {
 
         return replace( this._template,
-                        SnippetBuilder.PARAM,
+        				PARAM_STRING,
                         cellValue,
                         256 );
 
Index: drools-api/META-INF/MANIFEST.MF
===================================================================
--- drools-api/META-INF/MANIFEST.MF	(revision 33386)
+++ drools-api/META-INF/MANIFEST.MF	(working copy)
@@ -15,49 +15,49 @@
  "5.1.0.SNAPSHOT",org.drools.definition.process;uses:="org.drools.defi
  nition";version="5.1.0.SNAPSHOT",org.drools.util;uses:="org.drools,or
  g.drools.io,org.drools.builder";version="5.1.0.SNAPSHOT",org.drools.b
- uilder;uses:="org.drools.runtime,org.drools,org.drools.io,org.drools.
- definition,org.drools.builder.conf,org.drools.util";version="5.1.0.SN
- APSHOT",org.drools.builder.conf;uses:="org.drools.runtime.rule,org.dr
- ools.conf";version="5.1.0.SNAPSHOT",org.drools.logger;uses:="org.droo
- ls.event";version="5.1.0.SNAPSHOT",org.drools.runtime.process;uses:="
- org.drools.runtime";version="5.1.0.SNAPSHOT",org.drools.runtime.conf;
- uses:="org.drools.conf";version="5.1.0.SNAPSHOT",org.drools.runtime.h
- elp;uses:="com.thoughtworks.xstream,org.quartz,org.drools.time";versi
- on="5.1.0.SNAPSHOT",org.drools.time;version="5.1.0.SNAPSHOT",org.droo
- ls.event.rule;uses:="org.drools.event,org.drools.runtime.rule";versio
- n="5.1.0.SNAPSHOT",org.drools.definition.rule;uses:="org.drools.defin
- ition";version="5.1.0.SNAPSHOT",org.drools.osgi.api;uses:="org.osgi.f
- ramework,org.osgi.util.tracker,org.drools,org.drools.util";version="5
- .1.0.SNAPSHOT",org.drools.runtime.rule;uses:="org.drools.definition.r
- ule,org.drools.runtime";version="5.1.0.SNAPSHOT",org.drools.event.pro
- cess;uses:="org.drools.runtime.process,org.drools.event";version="5.1
- .0.SNAPSHOT",org.drools.definition;uses:="org.drools.definition.proce
- ss,org.drools.definition.rule";version="5.1.0.SNAPSHOT",org.drools.vs
- m;uses:="org.drools.command,org.drools.runtime,org.drools,org.drools.
- agent,org.drools.builder,org.drools.persistence.jpa";version="5.1.0.S
- NAPSHOT",org.drools.grid;uses:="org.drools.command";version="5.1.0.SN
- APSHOT",org.drools.builder.help;uses:="com.sun.tools.xjc,org.drools.i
- o,org.drools,org.drools.builder,javax.xml.bind";version="5.1.0.SNAPSH
- OT",org.drools.definition.type;version="5.1.0.SNAPSHOT",org.drools.io
- ;uses:="org.drools,org.drools.event.io,org.drools.util";version="5.1.
- 0.SNAPSHOT",org.drools.runtime.pipeline;uses:="org.drools.runtime,jav
- ax.xml.bind,net.sf.jxls.reader,org.milyn,com.thoughtworks.xstream";ve
- rsion="5.1.0.SNAPSHOT",org.drools.agent;uses:="org.drools.runtime,org
- .drools.io,org.drools";version="5.1.0.SNAPSHOT",org.drools.command;us
- es:="org.drools.runtime,org.drools.runtime.rule";version="5.1.0.SNAPS
- HOT",org.drools.task.service;version="5.1.0.SNAPSHOT",org.drools.pers
- istence.jpa;uses:="org.drools.runtime,org.drools";version="5.1.0.SNAP
- SHOT",org.drools.management;uses:="javax.management";version="5.1.0.S
- NAPSHOT",org.drools.command.impl;uses:="org.drools.command";version="
- 5.1.0.SNAPSHOT"
+ uilder;uses:="org.drools.runtime,org.drools,com.sun.tools.xjc,org.dro
+ ols.io,org.drools.definition,org.drools.builder.conf,org.drools.util"
+ ;version="5.1.0.SNAPSHOT",org.drools.builder.conf;uses:="org.drools.r
+ untime.rule,org.drools.conf";version="5.1.0.SNAPSHOT",org.drools.logg
+ er;uses:="org.drools.event";version="5.1.0.SNAPSHOT",org.drools.runti
+ me.process;uses:="org.drools.runtime";version="5.1.0.SNAPSHOT",org.dr
+ ools.runtime.conf;uses:="org.drools.conf";version="5.1.0.SNAPSHOT",or
+ g.drools.runtime.help;uses:="com.thoughtworks.xstream,org.quartz,org.
+ drools.time";version="5.1.0.SNAPSHOT",org.drools.time;version="5.1.0.
+ SNAPSHOT",org.drools.event.rule;uses:="org.drools.event,org.drools.ru
+ ntime.rule";version="5.1.0.SNAPSHOT",org.drools.definition.rule;uses:
+ ="org.drools.definition";version="5.1.0.SNAPSHOT",org.drools.osgi.api
+ ;uses:="org.osgi.framework,org.osgi.util.tracker,org.drools,org.drool
+ s.util";version="5.1.0.SNAPSHOT",org.drools.runtime.rule;uses:="org.d
+ rools.definition.rule,org.drools.runtime";version="5.1.0.SNAPSHOT",or
+ g.drools.event.process;uses:="org.drools.runtime.process,org.drools.e
+ vent";version="5.1.0.SNAPSHOT",org.drools.definition;uses:="org.drool
+ s.definition.process,org.drools.definition.rule";version="5.1.0.SNAPS
+ HOT",org.drools.vsm;uses:="org.drools.command,org.drools.runtime,org.
+ drools,org.drools.agent,org.drools.builder,org.drools.persistence.jpa
+ ";version="5.1.0.SNAPSHOT",org.drools.grid;uses:="org.drools.command"
+ ;version="5.1.0.SNAPSHOT",org.drools.builder.help;uses:="com.sun.tool
+ s.xjc,org.drools.io,org.drools,org.drools.builder,javax.xml.bind";ver
+ sion="5.1.0.SNAPSHOT",org.drools.definition.type;version="5.1.0.SNAPS
+ HOT",org.drools.io;uses:="org.drools,org.drools.event.io,org.drools.u
+ til";version="5.1.0.SNAPSHOT",org.drools.runtime.pipeline;uses:="org.
+ drools.runtime,javax.xml.bind,net.sf.jxls.reader,org.milyn,com.though
+ tworks.xstream";version="5.1.0.SNAPSHOT",org.drools.agent;uses:="org.
+ drools.runtime,org.drools.io,org.drools";version="5.1.0.SNAPSHOT",org
+ .drools.command;uses:="org.drools.runtime,org.drools.runtime.rule";ve
+ rsion="5.1.0.SNAPSHOT",org.drools.task.service;version="5.1.0.SNAPSHO
+ T",org.drools.persistence.jpa;uses:="org.drools.runtime,org.drools";v
+ ersion="5.1.0.SNAPSHOT",org.drools.management;uses:="javax.management
+ ";version="5.1.0.SNAPSHOT",org.drools.command.impl;uses:="org.drools.
+ command";version="5.1.0.SNAPSHOT"
 Private-Package: .;version="5.1.0.SNAPSHOT"
 Tool: Bnd-0.0.357
 Bundle-Name: Drools :: API
-Created-By: 1.6.0_18 (Sun Microsystems Inc.)
+Created-By: 1.6.0_20 (Sun Microsystems Inc.)
 Bundle-Vendor: JBoss Inc.
 DynamicImport-Package: *
 Bundle-Version: 5.1.0.SNAPSHOT
-Bnd-LastModified: 1275721110390
+Bnd-LastModified: 1275946195618
 Bundle-Activator: org.drools.osgi.api.Activator
 Bundle-ManifestVersion: 2
 Bundle-Description: A rule production system
Index: drools-process/drools-bpmn2/META-INF/MANIFEST.MF
===================================================================
--- drools-process/drools-bpmn2/META-INF/MANIFEST.MF	(revision 33386)
+++ drools-process/drools-bpmn2/META-INF/MANIFEST.MF	(working copy)
@@ -1,30 +1,28 @@
 Manifest-Version: 1.0
-Bundle-Activator: org.drools.osgi.bpmn2.Activator
-Created-By: 1.5.0_21 (Sun Microsystems Inc.)
-Bundle-License: http://www.apache.org/licenses/LICENSE-2.0.txt
-Import-Package: org.osgi.framework;version="1.5",org.w3c.dom,org.xml.s
- ax
-Bnd-LastModified: 1267333501253
-Export-Package: org.drools.bpmn2;uses:="org.drools.bpmn2.xml";version=
- "5.1.0.SNAPSHOT",org.drools.bpmn2.core;version="5.1.0.SNAPSHOT",org.d
- rools.bpmn2.xpath;version="5.1.0.SNAPSHOT",org.drools.bpmn2.handler;v
- ersion="5.1.0.SNAPSHOT",org.drools.bpmn2.xml;uses:="org.drools.bpmn2.
- core,org.xml.sax,org.w3c.dom,org.drools.bpmn2.xml.di";version="5.1.0.
- SNAPSHOT",org.drools.bpmn2.xml.di;uses:="org.xml.sax,org.w3c.dom";ver
- sion="5.1.0.SNAPSHOT",org.drools.osgi.bpmn2;uses:="org.drools.bpmn2,o
- rg.osgi.framework";version="5.1.0.SNAPSHOT"
-Bundle-Version: 5.1.0.SNAPSHOT
-Bundle-Name: Drools :: Process :: BPMN2
-Bundle-Description: A rule production system
-Private-Package: .;version="5.1.0.SNAPSHOT"
-Bundle-DocURL: http://www.jboss.org/
-Originally-Created-By: 1.6.0_18 (Sun Microsystems Inc.)
-Bundle-Vendor: JBoss Inc.
-Bundle-ManifestVersion: 2
-Bundle-SymbolicName: org.drools.bpmn2;singleton:=true
+Export-Package: org.drools.osgi.bpmn2;uses:="org.drools.bpmn2,org.osgi
+ .framework";version="5.1.0.SNAPSHOT",org.drools.bpmn2.xpath;version="
+ 5.1.0.SNAPSHOT",org.drools.bpmn2.xml.di;uses:="org.w3c.dom,org.xml.sa
+ x,org.drools.bpmn2.core";version="5.1.0.SNAPSHOT",org.drools.bpmn2;us
+ es:="org.drools.bpmn2.xml";version="5.1.0.SNAPSHOT",org.drools.bpmn2.
+ handler;version="5.1.0.SNAPSHOT",org.drools.bpmn2.xml;uses:="org.w3c.
+ dom,org.drools.bpmn2.core,org.xml.sax,org.drools.bpmn2.xml.di";versio
+ n="5.1.0.SNAPSHOT",org.drools.bpmn2.core;version="5.1.0.SNAPSHOT"
 Tool: Bnd-0.0.357
+Bundle-Name: Drools :: Process :: BPMN2
+Created-By: 1.6.0_20 (Sun Microsystems Inc.)
 Require-Bundle: org.drools.core;bundle-version="5.1.0.SNAPSHOT", org.d
  rools.compiler;bundle-version="5.1.0.SNAPSHOT", org.drools.persistenc
  e-jpa;optional="true";bundle-version="5.1.0.SNAPSHOT"
+Bundle-Vendor: JBoss Inc.
 DynamicImport-Package: *
+Bundle-Version: 5.1.0.SNAPSHOT
+Bnd-LastModified: 1275944530265
+Bundle-Activator: org.drools.osgi.bpmn2.Activator
+Bundle-ManifestVersion: 2
+Bundle-Description: A rule production system
+Bundle-License: http://www.apache.org/licenses/LICENSE-2.0.txt
+Import-Package: org.osgi.framework;version="1.5",org.w3c.dom,org.xml.s
+ ax
+Bundle-SymbolicName: org.drools.bpmn2;singleton:=true
+Bundle-DocURL: http://www.jboss.org/
 