Index: trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/src/org/jboss/tools/jsf/vpe/richfaces/test/jbide/JBIDE1713Test.java
===================================================================
--- trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/src/org/jboss/tools/jsf/vpe/richfaces/test/jbide/JBIDE1713Test.java	(revision 23060)
+++ trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/src/org/jboss/tools/jsf/vpe/richfaces/test/jbide/JBIDE1713Test.java	(revision 23061)
@@ -112,7 +112,7 @@
 		String activeToggleStyle = activeToggle.getAttribute(HTML.ATTR_STYLE);
 		assertNotNull(activeToggleStyle);
 		assertEquals(
-				"background: red none repeat scroll 0% 0%; color: blue; -moz-background-clip: border; -moz-background-origin: padding; -moz-background-inline-policy: continuous;",
+				"color: blue; background: none repeat scroll 0% 0% red;",
 				activeToggleStyle);
 
 		// check active content
Index: trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/recursiveTreeNodesAdaptor.xhtml.xml
===================================================================
--- trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/recursiveTreeNodesAdaptor.xhtml.xml	(revision 23060)
+++ trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/recursiveTreeNodesAdaptor.xhtml.xml	(revision 23061)
@@ -7,12 +7,12 @@
 					<TBODY>
 						<TR>
 							<TD
-								STYLE="/background-image: url\(.*resources//tree/line.gif\); background-position: center center; background-repeat: repeat-y;/">
+								STYLE='/background-image: url\(".*resources//tree/line.gif"\); background-position: center center; background-repeat: repeat-y;/'>
 								<IMG CLASS="treePictureStyle" SRC="/.*resources/tree/iconClosedNodeWithLines.gif/"
 									RICHFACESTREENODEPARAM="DEFAULT_ICON_EXPANDED_PARAM" />
 							</TD>
 							<TD
-								STYLE="/background-image: url\(.*resources//tree/leftLine.gif\); background-position: center center; background-repeat: repeat-y;/">
+								STYLE='/background-image: url\(".*resources//tree/leftLine.gif"\); background-position: center center; background-repeat: repeat-y;/'>
 								<IMG CLASS="treePictureStyle" SRC="/.*resources/tree/iconNodeWithLines.gif/"
 									RICHFACESTREENODEPARAM="DEFAULT_ICON_PARAM" />
 							</TD>
@@ -33,7 +33,7 @@
 						<TBODY>
 							<TR>
 								<TD
-									STYLE="/background-image: url\(.*resources//tree/line.gif\); background-position: center center; background-repeat: repeat-y;/">
+									STYLE='/background-image: url\(".*resources//tree/line.gif"\); background-position: center center; background-repeat: repeat-y;/'>
 									<IMG CLASS="treePictureStyle"
 										SRC="/.*resources/tree/iconNotCollapsedWithAllLines.gif/"
 										RICHFACESTREENODEPARAM="DEFAULT_ICON_EXPANDED_PARAM" />
@@ -60,7 +60,7 @@
 						<TBODY>
 							<TR>
 								<TD
-									STYLE="/background-image: url\(.*resources//tree/line.gif\); background-position: center center; background-repeat: repeat-y;/">
+									STYLE='/background-image: url\(".*resources//tree/line.gif"\); background-position: center center; background-repeat: repeat-y;/'>
 									<IMG CLASS="treePictureStyle"
 										SRC="/.*resources/tree/iconNotCollapsedWithAllLines.gif/"
 										RICHFACESTREENODEPARAM="DEFAULT_ICON_EXPANDED_PARAM" />
@@ -87,7 +87,7 @@
 						<TBODY>
 							<TR>
 								<TD
-									STYLE="/background-image: url\(.*resources//tree/rightLine.gif\); background-position: center center; background-repeat: repeat-y;/">
+									STYLE='/background-image: url\(".*resources//tree/rightLine.gif"\); background-position: center center; background-repeat: repeat-y;/'>
 									<IMG CLASS="treePictureStyle"
 										SRC="/.*resources/tree/iconNotCollapsedWithLines.gif/"
 										RICHFACESTREENODEPARAM="DEFAULT_ICON_EXPANDED_PARAM" />
Index: trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/comboBox.xhtml.xml
===================================================================
--- trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/comboBox.xhtml.xml	(revision 23060)
+++ trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/comboBox.xhtml.xml	(revision 23061)
@@ -86,7 +86,7 @@
 	<test id="complexCombo">
 		<DIV CLASS="dr-pnl rich-panel btn">
 			<DIV CLASS="dr-pnl-h rich-panel-header"
-				STYLE="/background-image: url\(.*resources/common/background.gif\);/">
+				STYLE='/background-image: url\(".*resources/common/background.gif"\);/'>
 				<SPAN CLASS="vpe-text">
 					Combo Box
 				</SPAN>
Index: trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/toolBar.xhtml.xml
===================================================================
--- trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/toolBar.xhtml.xml	(revision 23060)
+++ trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/toolBar.xhtml.xml	(revision 23061)
@@ -2,7 +2,7 @@
 	<test id="toolBar">
 		<DIV>
 			<TABLE WIDTH="100%" CLASS="dr-toolbar-ext rich-toolbar"
-				STYLE="/background-image: url\(.*resources/common/background.gif\);/">
+				STYLE='/background-image: url\(".*resources/common/background.gif"\);/'>
 				<TBODY>
 					<TR VALIGN="middle">
 						<TD CLASS="dr-toolbar-int rich-toolbar-item" STYLE="padding: 0px;">
@@ -73,7 +73,7 @@
 	<test id="toolBar2">
 		<DIV CLASS="dr-pnl rich-panel">
 			<DIV CLASS="dr-pnl-h rich-panel-header"
-				STYLE="/background-image: url\(.*resources/common/background.gif\);/">
+				STYLE='/background-image: url\(".*resources/common/background.gif"\);/'>
 				<SPAN CLASS="vpe-text">
 					Tool Bar &amp; Tool Bar  Group
 				</SPAN>
@@ -81,7 +81,7 @@
 			<DIV CLASS="dr-pnl-b rich-panel-body">
 				<DIV>
 					<TABLE WIDTH="100%" HEIGHT="26" CLASS="dr-toolbar-ext rich-toolbar btn"
-						STYLE="/background-image: url\(.*resources/common/background.gif\);/">
+						STYLE='/background-image: url\(".*resources/common/background.gif"\);/'>
 						<TBODY>
 							<TR VALIGN="middle">
 								<TD CLASS="dr-toolbar-int rich-toolbar-item btn" STYLE="padding: 0px;">
@@ -177,7 +177,7 @@
 					<DIV>
 						<TABLE WIDTH="100%" HEIGHT="34"
 							CLASS="dr-toolbar-ext rich-toolbar evenRow"
-							STYLE="/background-image: url\(.*resources/common/background.gif\);/">
+							STYLE='/background-image: url\(".*resources/common/background.gif"\);/'>
 							<TBODY>
 								<TR VALIGN="middle">
 									<TD CLASS="dr-toolbar-int rich-toolbar-item"
@@ -393,7 +393,7 @@
 				</FORM>
 				<DIV>
 					<TABLE WIDTH="100%" HEIGHT="30" CLASS="dr-toolbar-ext rich-toolbar"
-						STYLE="/background-image: url\(.*resources/common/background.gif\); color: Cornsilk; font-style: italic; background-color: Orchid; text-decoration: underline; font-family: Arial Narrow,Bodoni MT; font-weight: bold;/">
+						STYLE='/background-image: url\(".*resources/common/background.gif"\); color: Cornsilk; font-style: italic; background-color: Orchid; text-decoration: underline; font-family: Arial Narrow,Bodoni MT; font-weight: bold;/'>
 						<TBODY>
 							<TR VALIGN="middle">
 								<TD CLASS="dr-toolbar-int rich-toolbar-item btn"
Index: trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/treeNodesAdaptor.xhtml.xml
===================================================================
--- trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/treeNodesAdaptor.xhtml.xml	(revision 23060)
+++ trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/treeNodesAdaptor.xhtml.xml	(revision 23061)
@@ -7,13 +7,13 @@
 					<TBODY>
 						<TR>
 							<TD
-								STYLE="/background-image: url\(.*resources//tree/line.gif\); background-position: center center; background-repeat: repeat-y;/">
+								STYLE='/background-image: url\(".*resources//tree/line.gif"\); background-position: center center; background-repeat: repeat-y;/'>
 								<IMG CLASS="treePictureStyle"
 									SRC="/.*resources/tree/iconClosedNodeWithLines.gif/"
 									RICHFACESTREENODEPARAM="DEFAULT_ICON_EXPANDED_PARAM" />
 							</TD>
 							<TD
-								STYLE="/background-image: url\(.*resources//tree/leftLine.gif\); background-position: center center; background-repeat: repeat-y;/">
+								STYLE='/background-image: url\(".*resources//tree/leftLine.gif"\); background-position: center center; background-repeat: repeat-y;/'>
 								<IMG CLASS="treePictureStyle"
 									SRC="/.*resources/tree/iconNodeWithLines.gif/"
 									RICHFACESTREENODEPARAM="DEFAULT_ICON_PARAM" />
@@ -35,13 +35,13 @@
 						<TBODY>
 							<TR>
 								<TD
-									STYLE="/background-image: url\(.*resources//tree/line.gif\); background-position: center center; background-repeat: repeat-y;/">
+									STYLE='/background-image: url\(".*resources//tree/line.gif"\); background-position: center center; background-repeat: repeat-y;/'>
 									<IMG CLASS="treePictureStyle"
 										SRC="/.*resources/tree/iconClosedNodeWithLines.gif/"
 										RICHFACESTREENODEPARAM="DEFAULT_ICON_EXPANDED_PARAM" />
 								</TD>
 								<TD
-									STYLE="/background-image: url\(.*resources//tree/leftLine.gif\); background-position: center center; background-repeat: repeat-y;/">
+									STYLE='/background-image: url\(".*resources//tree/leftLine.gif"\); background-position: center center; background-repeat: repeat-y;/'>
 									<IMG CLASS="treePictureStyle"
 										SRC="/.*resources/tree/iconNodeWithLines.gif/"
 										RICHFACESTREENODEPARAM="DEFAULT_ICON_PARAM" />
@@ -63,13 +63,13 @@
 							<TBODY>
 								<TR>
 									<TD
-										STYLE="/background-image: url\(.*resources//tree/line.gif\); background-position: center center; background-repeat: repeat-y;/">
+										STYLE='/background-image: url\(".*resources//tree/line.gif"\); background-position: center center; background-repeat: repeat-y;/'>
 										<IMG CLASS="treePictureStyle"
 											SRC="/.*resources/tree/iconClosedNodeWithLines.gif/"
 											RICHFACESTREENODEPARAM="DEFAULT_ICON_EXPANDED_PARAM" />
 									</TD>
 									<TD
-										STYLE="/background-image: url\(.*resources//tree/leftLine.gif\); background-position: center center; background-repeat: repeat-y;/">
+										STYLE='/background-image: url\(".*resources//tree/leftLine.gif"\); background-position: center center; background-repeat: repeat-y;/'>
 										<IMG CLASS="treePictureStyle"
 											SRC="/.*resources/tree/iconNodeWithLines.gif/"
 											RICHFACESTREENODEPARAM="DEFAULT_ICON_PARAM" />
@@ -91,7 +91,7 @@
 								<TBODY>
 									<TR>
 										<TD
-											STYLE="/background-image: url\(.*resources//tree/rightLine.gif\); background-position: center center; background-repeat: repeat-y;/">
+											STYLE='/background-image: url\(".*resources//tree/rightLine.gif"\); background-position: center center; background-repeat: repeat-y;/'>
 											<IMG CLASS="treePictureStyle"
 												SRC="/.*resources/tree/iconNotCollapsedWithLines.gif/"
 												RICHFACESTREENODEPARAM="DEFAULT_ICON_EXPANDED_PARAM" />
Index: trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/treeNode.xhtml.xml
===================================================================
--- trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/treeNode.xhtml.xml	(revision 23060)
+++ trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/treeNode.xhtml.xml	(revision 23061)
@@ -6,13 +6,13 @@
                 <TBODY>
                     <TR>
                         <TD
-                            STYLE="/background-image: url\(.*resources//tree/rightLine.gif\); background-position: center center; background-repeat: repeat-y;/">
+                            STYLE='/background-image: url\(".*resources//tree/rightLine.gif"\); background-position: center center; background-repeat: repeat-y;/'>
                             <IMG CLASS="treePictureStyle"
                                 SRC="/.*resources/tree/iconCollapsedWithLines.gif/"
                                 RICHFACESTREENODEPARAM="DEFAULT_ICON_EXPANDED_PARAM"/>
                         </TD>
                         <TD
-                            STYLE="/background-image: url\(.*resources//tree/leftLine.gif\); background-position: center center; background-repeat: repeat-y;/">
+                            STYLE='/background-image: url\(".*resources//tree/leftLine.gif"\); background-position: center center; background-repeat: repeat-y;/'>
                             <IMG CLASS="treePictureStyle"
                                 SRC="/.*resources/tree/iconNodeWithLines.gif/"
                                 RICHFACESTREENODEPARAM="DEFAULT_ICON_PARAM"/>
Index: trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/dataTable.xhtml.xml
===================================================================
--- trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/dataTable.xhtml.xml	(revision 23060)
+++ trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/dataTable.xhtml.xml	(revision 23061)
@@ -6,7 +6,7 @@
 			</COLGROUP>
 			<THEAD>
 				<TR CLASS="dr-table-header rich-table-header"
-					STYLE="/background-image: url\(.*resources/common/background.gif\);/">
+					STYLE='/background-image: url\(".*resources/common/background.gif"\);/'>
 					<TD ROWSPAN="2" CLASS="dr-table-headercell rich-table-headercell">
 						<IMG WIDTH="1px" HEIGHT="1px" SRC="/.*resources/spacer/spacer.gif/"/>
 					</TD>
Index: trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/simpleTogglePanel.xhtml.xml
===================================================================
--- trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/simpleTogglePanel.xhtml.xml	(revision 23060)
+++ trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/simpleTogglePanel.xhtml.xml	(revision 23061)
@@ -2,7 +2,7 @@
 	<test id="simpleTogglePanel">
 		<DIV CLASS="dr-stglpnl rich-stglpanel" STYLE="">
 			<DIV CLASS="dr-stglpnl-h rich-stglpanel-header"
-				STYLE="/position: relative; background-image: url\(.*resources/common/background.gif\);/"
+				STYLE='/position: relative; background-image: url\(".*resources/common/background.gif"\);/'
 				VPE-USER-TOGGLE-ID="false">
 				Add AJAX capability to existing JSF applications
 				<DIV STYLE="position: absolute; top: 0px; right: 5px;"
Index: trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/tree.xhtml.xml
===================================================================
--- trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/tree.xhtml.xml	(revision 23060)
+++ trunk/jsf/tests/org.jboss.tools.jsf.vpe.richfaces.test/resources/richFacesTest/WebContent/pages/components/tree.xhtml.xml	(revision 23061)
@@ -7,12 +7,12 @@
 					<TBODY>
 						<TR>
 							<TD
-								STYLE="/background-image: url\(.*resources//tree/rightLine.gif\); background-position: center center; background-repeat: repeat-y;/">
+								STYLE='/background-image: url\(".*resources//tree/rightLine.gif"\); background-position: center center; background-repeat: repeat-y;/'>
 								<IMG CLASS="treePictureStyle" SRC="/.*resources/tree/iconCollapsedWithLines.gif/"
 									RICHFACESTREENODEPARAM="DEFAULT_ICON_EXPANDED_PARAM" />
 							</TD>
 							<TD
-								STYLE="/background-image: url\(.*resources//tree/leftLine.gif\); background-position: center center; background-repeat: repeat-y;/">
+								STYLE='/background-image: url\(".*resources//tree/leftLine.gif"\); background-position: center center; background-repeat: repeat-y;/'>
 								<IMG CLASS="treePictureStyle" SRC="/.*resources/tree/iconNodeWithLines.gif/"
 									RICHFACESTREENODEPARAM="DEFAULT_ICON_PARAM" />
 							</TD>
@@ -30,12 +30,12 @@
 						<TBODY>
 							<TR>
 								<TD
-									STYLE="/background-image: url\(.*resources//tree/rightLine.gif\); background-position: center center; background-repeat: repeat-y;/">
+									STYLE='/background-image: url\(".*resources//tree/rightLine.gif"\); background-position: center center; background-repeat: repeat-y;/'>
 									<IMG CLASS="treePictureStyle" SRC="/.*resources/tree/iconCollapsedWithLines.gif/"
 										RICHFACESTREENODEPARAM="DEFAULT_ICON_EXPANDED_PARAM" />
 								</TD>
 								<TD
-									STYLE="/background-image: url\(.*resources//tree/leftLine.gif\); background-position: center center; background-repeat: repeat-y;/">
+									STYLE='/background-image: url\(".*resources//tree/leftLine.gif"\); background-position: center center; background-repeat: repeat-y;/'>
 									<IMG CLASS="treePictureStyle" SRC="/.*resources/tree/iconNodeWithLines.gif/"
 										RICHFACESTREENODEPARAM="DEFAULT_ICON_PARAM" />
 								</TD>
@@ -53,7 +53,7 @@
 							<TBODY>
 								<TR>
 									<TD
-										STYLE="/background-image: url\(.*resources//tree/rightLine.gif\); background-position: center center; background-repeat: repeat-y;/">
+										STYLE='/background-image: url\(".*resources//tree/rightLine.gif"\); background-position: center center; background-repeat: repeat-y;/'>
 										<IMG CLASS="treePictureStyle"
 											SRC="/.*resources/tree/iconNotCollapsedWithLines.gif/"
 											RICHFACESTREENODEPARAM="DEFAULT_ICON_EXPANDED_PARAM" />