Index: ejb3/src/main/java/org/jboss/ejb3/deployers/Ejb3Deployer.java
===================================================================
--- ejb3/src/main/java/org/jboss/ejb3/deployers/Ejb3Deployer.java	(revision 109235)
+++ ejb3/src/main/java/org/jboss/ejb3/deployers/Ejb3Deployer.java	(working copy)
@@ -41,6 +41,7 @@
 import org.jboss.ejb3.common.registrar.plugin.mc.Ejb3McRegistrar;
 import org.jboss.ejb3.common.registrar.spi.Ejb3Registrar;
 import org.jboss.ejb3.common.registrar.spi.Ejb3RegistrarLocator;
+import org.jboss.ejb3.instantiator.spi.BeanInstantiator;
 import org.jboss.ejb3.pool.PoolFactoryRegistry;
 import org.jboss.ejb3.resolvers.MessageDestinationReferenceResolver;
 import org.jboss.jpa.resolvers.PersistenceUnitDependencyResolver;
@@ -89,6 +90,7 @@
 	   // we also want post processed metadata for processing.
 	   // Using addInput ensures ordering http://www.jboss.org/index.html?module=bb&op=viewtopic&t=156725
       addInput(AttachmentNames.PROCESSED_METADATA);
+      addInput(BeanInstantiator.class);
       // TODO: should we really output this
       setOutput(Ejb3Deployment.class);
       // JBossASKernel install output
Index: ejb3/src/resources/META-INF/ejb3-as-deployers-jboss-beans.xml
===================================================================
--- ejb3/src/resources/META-INF/ejb3-as-deployers-jboss-beans.xml	(revision 109235)
+++ ejb3/src/resources/META-INF/ejb3-as-deployers-jboss-beans.xml	(working copy)
@@ -309,6 +309,13 @@
         TODO: Remove this once the dependents move to the new ejbref-resolver SPI  -->
     <bean name="org.jboss.ejb3.EjbReferenceResolver" class="org.jboss.ejb3.core.resolvers.ScopedEJBReferenceResolver"/>
   
-   
+    <!-- Responsible for creating the piece used to create EJB3 Bean Instances -->
+    <bean name="org.jboss.ejb3.BeanInstantiator" class="org.jboss.ejb3.instantiator.impl.Ejb31SpecBeanInstantiator" />
+    <bean name="org.jboss.ejb3.BeanInstantiatorDeployer" class="org.jboss.ejb3.instantiator.deployer.SingletonBeanInstantiatorDeployer"> 
+      <constructor>
+        <parameter class="org.jboss.ejb3.instantiator.spi.BeanInstantiator"><inject bean="org.jboss.ejb3.BeanInstantiator"/></parameter>
+      </constructor>
+      <property name="kernel"><inject bean="jboss.kernel:service=Kernel"/></property>
+    </bean>
 
 </deployment>
Index: component-matrix/pom.xml
===================================================================
--- component-matrix/pom.xml	(revision 109235)
+++ component-matrix/pom.xml	(working copy)
@@ -84,7 +84,7 @@
     <version.org.jboss.cluster.server.ispn>1.0.0.CR4</version.org.jboss.cluster.server.ispn>
     <version.org.jboss.common.core>2.2.17.GA</version.org.jboss.common.core>
     <version.org.jboss.deployers>2.2.0.Alpha8</version.org.jboss.deployers>
-    <version.org.jboss.ejb3.depchain>1.0.0-alpha-15</version.org.jboss.ejb3.depchain>
+    <version.org.jboss.ejb3.depchain>1.0.0-alpha-16</version.org.jboss.ejb3.depchain>
     <!-- This to move into the EJB3 BOM -->
     <version.org.jboss.ejb3.embedded>1.0.0-alpha-1</version.org.jboss.ejb3.embedded>
     <version.org.jboss.ejb.api>1.0-alpha-1</version.org.jboss.ejb.api>
@@ -112,7 +112,7 @@
     <version.org.jboss.metadata.client>2.0.0.Alpha2</version.org.jboss.metadata.client>
     <version.org.jboss.metadata.common>2.0.0.Alpha19</version.org.jboss.metadata.common>
     <version.org.jboss.metadata.ear>2.0.0.Alpha4</version.org.jboss.metadata.ear>
-    <version.org.jboss.metadata.ejb>2.0.0-alpha-21</version.org.jboss.metadata.ejb>
+    <version.org.jboss.metadata.ejb>2.0.0-alpha-22</version.org.jboss.metadata.ejb>
     <version.org.jboss.metadata.rar>2.0.0.Alpha</version.org.jboss.metadata.rar>
     <version.org.jboss.metadata.war>2.0.0.Alpha15</version.org.jboss.metadata.war>
     <version.org.jboss.mod_cluster>1.1.0.CR3</version.org.jboss.mod_cluster>
Index: build/build.xml
===================================================================
--- build/build.xml	(revision 109235)
+++ build/build.xml	(working copy)
@@ -694,12 +694,10 @@
 	      <include name="ejb3-nointerface-jboss-beans.xml"/>
 	      <include name="ejb3-metadata-deployers-jboss-beans.xml"/>
 		  <include name="jboss-ejb3-singleton-deployer-jboss-beans.xml"/>
-		  <include name="ejb3-bean-instantiator-jboss-beans.xml"/>
 		  
       </fileset>
       <fileset refid="org.jboss.ejb3:jboss-ejb3-timerservice-deployer:jar"/>
       <fileset refid="org.jboss.ejb3.async:jboss-ejb3-async-deployer:jar"/>
-      <fileset refid="org.jboss.ejb3.instantiator:jboss-ejb3-instantiator-deployer:jar"/>
       <fileset refid="org.jboss.ejb3.jndi:jboss-ejb3-jndi-deployers:jar"/>
       <!-- Strip version numbers from the jar names -->
 	  <mapper refid="remove-versions" />      
@@ -2052,6 +2050,9 @@
       <fileset refid="org.jboss.ejb3.container:jboss-ejb3-container-spi:jar"/>
       <fileset refid="org.jboss.ejb3.context:jboss-ejb3-context-base:jar"/>
       <fileset refid="org.jboss.ejb3.context:jboss-ejb3-context-naming:jar"/>
+      <fileset refid="org.jboss.ejb3.effigy:jboss-ejb3-effigy-api:jar"/>
+      <fileset refid="org.jboss.ejb3.effigy:jboss-ejb3-effigy-common:jar"/>
+      <fileset refid="org.jboss.ejb3.effigy:jboss-ejb3-effigy-int2:jar"/>
       <fileset refid="org.jboss.ejb3.ejbref.resolver:ejbref-resolver-spi:jar"/>
       <fileset refid="org.jboss.ejb3.ejbref.resolver:ejbref-resolver-ejb30-impl:jar"/>      
       <fileset refid="org.jboss.ejb3.ejbref.resolver:ejbref-resolver-ejb31-impl:jar"/>      
@@ -2087,7 +2088,8 @@
       <fileset refid="org.jboss.ejb3:jboss-ejb3-timerservice-spi:jar"/>
       <fileset refid="org.jboss.ejb3:jboss-ejb3-transactions:jar"/>
       <fileset refid="org.jboss.ejb3.instantiator:jboss-ejb3-instantiator-spi:jar"/>
-      <fileset refid="org.jboss.ejb3.instantiator:jboss-ejb3-instantiator-impl:jar"/>      
+      <fileset refid="org.jboss.ejb3.instantiator:jboss-ejb3-instantiator-impl:jar"/>
+      <fileset refid="org.jboss.ejb3.instantiator:jboss-ejb3-instantiator-deployer:jar"/>      
       <fileset refid="org.jboss.ejb3.proxy:proxy-spi:jar"/>
       <fileset refid="org.jboss.ejb3.proxy:proxy-javassist:jar"/>
       <fileset refid="org.jboss.ejb3.proxy:proxy-reflect:jar"/>